﻿using Syncfusion.UI.Xaml.Grid;
using Syncfusion.UI.Xaml.ScrollAxis;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using Syncfusion.UI.Xaml.Grid.Helpers;

namespace TabKeyBehavior_WPF
{
    public class CustomSelectionController : GridSelectionController
    {
        public CustomSelectionController(SfDataGrid dataGrid)
            : base(dataGrid)
        {
        }

        protected override void ProcessKeyDown(KeyEventArgs args)
        {
            // Get the CurrentCell column index
            var currentColumnIndex = this.CurrentCellManager.CurrentRowColumnIndex.ColumnIndex;
            // Get last column index of the SfDataGrid through the SelectionHelper
            var lastIndex = SelectionHelper.GetLastColumnIndex(DataGrid);
           
            bool isAddNewRow = DataGrid.IsAddNewIndex(CurrentCellManager.CurrentRowColumnIndex.RowIndex);
            base.ProcessKeyDown(args);
            if (args.Key == Key.Tab && isAddNewRow && this.DataGrid.AddNewRowPosition == AddNewRowPosition.Bottom)
            {
                var columnIndex = currentColumnIndex == lastIndex ? GetNextFocusedColumnIndex(0) : GetNextFocusedColumnIndex(currentColumnIndex);
                this.MoveCurrentCell(new RowColumnIndex(this.CurrentCellManager.CurrentRowColumnIndex.RowIndex,
                    columnIndex));
                this.DataGrid.ScrollInView(this.CurrentCellManager.CurrentRowColumnIndex);
            }
        }

       
        //Get the Next Focused Index when Move to new line
        public int GetNextFocusedColumnIndex(int index)
        {
            int temp = 0;
            temp = index + 1;
            var dataColumn = SelectionHelper.GetDataColumnBase(this.DataGrid, new RowColumnIndex(this.CurrentCellManager.CurrentRowColumnIndex.RowIndex, temp));
            while (dataColumn != null && (!dataColumn.GridColumn.AllowFocus || dataColumn.GridColumn.IsHidden))
            {
                temp++;
                dataColumn = SelectionHelper.GetDataColumnBase(this.DataGrid, new RowColumnIndex(this.CurrentCellManager.CurrentRowColumnIndex.RowIndex, temp));
                if (dataColumn == null)
                {
                    temp = 0;
                    dataColumn = SelectionHelper.GetDataColumnBase(this.DataGrid, new RowColumnIndex(this.CurrentCellManager.CurrentRowColumnIndex.RowIndex, temp));
                }
            }
            return this.DataGrid.ResolveToScrollColumnIndex(temp);
        }
       

    }

}
